include \masm32\MasmBasic\MasmBasic.inc 
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

TestCorrectness = 0

.data
Src	db "This is a string, many characters long, that serves for a variety of purposes, such as testing algos"
	REPEAT 99
	db "This is a string, many characters long, that serves for a variety of purposes, such as testing algos"
	ENDM
	db 0
.data?
align 16
;spoiler	db ?,?
Dest1	db 1024 dup(?)
Dest2	db 1024 dup(?)
Dest3	db 1024 dup(?)
Dest4	db 1024 dup(?)
Dest5	db 1024 dup(?)

.code
PushCopy proc dest, src, count
  mov esi, src
  mov esp, dest
  add esi, count
  add esp, count
  pop eax
  std
  .Repeat
	lodsd
	push eax
  .Until esp<=dest
  cld
  ret
PushCopy endp

PopCopy proc dest, src, count
  mov esp, src
  mov edi, dest
  mov ecx, count
  add ecx, edi
  .Repeat
	pop eax
	if 1
		mov [edi], eax
		add edi, 4
	else
		stosd
	endif
  .Until edi>=ecx
  ret
PopCopy endp

start:	push 1
	call ShowCpu	; print brand string and SSE level
		ByteCount = 50
		if TestCorrectness
				invoke PopCopy, offset Dest3, offset Src, ByteCount
				print offset Dest3, 13, 10
				invoke MbCopy, offset Dest1, offset Src, ByteCount
				print offset Dest1, 13, 10
;				invoke PushCopy, offset Dest2, offset Src, ByteCount
;				print offset Dest2, 13, 10
				invoke MemCopy, offset Src, offset Dest4, ByteCount
				print offset Dest4, 13, 10
				invoke RtlMoveMemory, offset Dest5, offset Src, ByteCount
				print offset Dest5, 13, 10
			endif

	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	REPEAT 4
		print "test with "
		print str$(ByteCount), " bytes", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke PopCopy, offset Dest3, offset Src, ByteCount
		counter_end
		print str$(eax), 9, "cycles for PopCopy", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke MbCopy, offset Dest1, offset Src, ByteCount
		counter_end
		print str$(eax), 9, "cycles for MbCopy", 13, 10
;		invoke Sleep, SleepMs
;		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;				invoke PushCopy, offset Dest2, offset Src, ByteCount
;		counter_end
;		print str$(eax), 9, "cycles for PushCopy", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke MemCopy, offset Src, offset Dest4, ByteCount
		counter_end
		print str$(eax), 9, "cycles for MemCopy", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke RtlMoveMemory, offset Dest3, offset Src, ByteCount
		counter_end
		print str$(eax), 9, "cycles for RtlMoveMemory", 13, 10
		print chr$(13, 10)
		ByteCount = ByteCount*4
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]